"
 COPYRIGHT (c) 1997 by Claus Gittinger / eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"




Object subclass:#DataSetColumn
	instanceVariableNames:'dataSet label minWidth width description form form2 formInset
		textInset writeSelector shadowForm drawableAction'
	classVariableNames:'FormComboView FormToggleOn FormToggleOff FormShadow
		FormRowSelector'
	poolDictionaries:''
	category:'Views-DataSet'
!

!DataSetColumn class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by Claus Gittinger / eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



!

documentation
"
    represent one single column description of a DataSetView

    [Instance variables:]

        description     <DataSetColumnSpec>     the column description
        dataSet         <DSVColumnView>         the view it belongs to
        width           <Integer>               width of column
        minWidth        <Integer>               minimum required width by the column
        formInset       <Integer>               top inset of a form
        textInset       <Integer>               top inset of a string
        form            <Form>                  a form drawn when a cell is unselected
        form2           <Form>                  a second form (used by Toggle off).
        shadowForm      <Form>                  used to shadow form and form2 (3D-Effect)
        label           <misc>                  cellLabel on device
        writeSelector   <Selector>              to write back a value

    [author:]
        Claus Atzkern

    [see also:]
        DataSetColumnSpec
        DSVColumnView
        DataSetView
"


! !

!DataSetColumn class methodsFor:'instance creation'!

on:aDSVColumnView description:aDescription
    "instance creation
    "
    ^ self new on:aDSVColumnView description:aDescription

! !

!DataSetColumn class methodsFor:'constants'!

formComboView
    "returns combo form (used by #ComboList #ComboBox)
    "
    FormComboView notNil ifTrue:[
        ^ FormComboView
    ].

    FormComboView := Form
                  width:24
                 height:22 
              fromArray:#[2r00000000 2r00000000 2r00000000
                          2r00111111 2r11111111 2r11111100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00111100 2r00001100
                          2r00100000 2r00111100 2r00000100
                          2r00100000 2r00111100 2r00001100
                          2r00100000 2r00111100 2r00000100
                          2r00100000 2r00111100 2r00001100
                          2r00100001 2r11111111 2r10000100
                          2r00100000 2r11111111 2r00001100
                          2r00100000 2r01111110 2r00000100
                          2r00100000 2r00111100 2r00001100
                          2r00100000 2r00011000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100001 2r11111111 2r10000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00101010 2r10101010 2r10101100
                          2r00111111 2r11111111 2r11111100
                          2r00000000 2r00000000 2r00000000]
                     on:Display.

    ^ FormComboView.

"
FormComboView := nil
"




!

formRowSelector
    "returns form used by rowSelector
    "
    FormRowSelector notNil ifTrue:[
        ^ FormRowSelector
    ].

    FormRowSelector := Form
                  width:8
                 height:11
              fromArray:#[2r01000000
                          2r01100000
                          2r01110000
                          2r01111000
                          2r01111100
                          2r01111110
                          2r01111100
                          2r01111000
                          2r01110000
                          2r01100000
                          2r01000000]
                     on:Display.

    ^ FormRowSelector.

"
FormRowSelector := nil
"


!

formShadow
    "returns shadow form used by buttons
    "
    FormShadow notNil ifTrue:[
        ^ FormShadow
    ].

    FormShadow := Form
                  width:24
                 height:22 
              fromArray:#[2r00000000 2r00000000 2r00000000
                          2r00000000 2r00000000 2r00000000
                          2r00011111 2r11111111 2r11111000
                          2r00011111 2r11111111 2r11110000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00011000 2r00000000 2r00000000
                          2r00010000 2r00000000 2r00000000
                          2r00000000 2r00000000 2r00000000
                          2r00000000 2r00000000 2r00000000]
                     on:Display.

    ^ FormShadow.

"
FormShadow := nil
"


!

formToggleOff
    "returns toggle-OFF form (used by #CheckToggle value:false)
    "
    FormToggleOff notNil ifTrue:[
        ^ FormToggleOff
    ].

    FormToggleOff := Form
                  width:24
                 height:22 
              fromArray:#[2r00000000 2r00000000 2r00000000
                          2r00111111 2r11111111 2r11111100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00101010 2r10101010 2r10101100
                          2r00111111 2r11111111 2r11111100
                          2r00000000 2r00000000 2r00000000]
                     on:Display.

    ^ FormToggleOff.

"
FormToggleOff := nil
"


!

formToggleOn
    "returns toggle-ON form (used by #CheckToggle value:true )
    "
    FormToggleOn notNil ifTrue:[
        ^ FormToggleOn
    ].

    FormToggleOn := Form
                  width:24
                 height:22 
              fromArray:#[2r00000000 2r00000000 2r00000000
                          2r00111111 2r11111111 2r11111100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00100111 2r00000001 2r11001100
                          2r00100011 2r10000011 2r10000100
                          2r00100001 2r11000111 2r00001100
                          2r00100000 2r11101110 2r00000100
                          2r00100000 2r01111100 2r00001100
                          2r00100000 2r00111000 2r00000100
                          2r00100000 2r01111100 2r00001100
                          2r00100000 2r11101110 2r00000100
                          2r00100001 2r11000111 2r00001100
                          2r00100011 2r10000011 2r10000100
                          2r00100111 2r00000001 2r11001100
                          2r00100000 2r00000000 2r00000100
                          2r00100000 2r00000000 2r00001100
                          2r00100000 2r00000000 2r00000100
                          2r00101010 2r10101010 2r10101100
                          2r00111111 2r11111111 2r11111100
                          2r00000000 2r00000000 2r00000000]
                     on:Display.

    ^ FormToggleOn.

"
FormToggleOn := nil
"




! !

!DataSetColumn methodsFor:'accessing'!

at:aRowNr
    "get the value of the raw at an index, aRowNr
    "
    ^ (dataSet at:aRowNr) perform:(description readSelector)
!

at:aRowNr put:something
    "set the value of the raw at an index, aRowNr
    "
    writeSelector notNil ifTrue:[
        (dataSet at:aRowNr) perform:writeSelector with:something
    ]
!

label
    "get the label assigned to the column
    "
    ^ label


!

width
    "returns the width in pixels
    "
    |end|

    width notNil ifTrue:[ ^ width ].                            "/ already computed

    (    (width := description width)    ~~ 0                   "/ fixed size
     or:[(width := description minWidth) ~~ 0]                  "/ start size
    ) ifTrue:[
        ^ minWidth := width
    ].
    drawableAction notNil ifTrue:[
        "/ take maximum 10 entries to calculate the width;
        "/ can be resized later if neccessary

        end := 10 min:dataSet numberOfRows.

        1 to:end do:[:aRowNr||lbl|
            lbl := drawableAction value:aRowNr.

            (lbl respondsTo:#widthOn:) ifTrue:[
                width := width max:(lbl widthOn:dataSet)
            ] ifFalse:[
                lbl notNil ifTrue:[
                    width := width max:(lbl displayString widthOn:dataSet)
                ]
            ]
        ].
        description editorType ~~ #None ifTrue:[
            width := width + (dataSet font widthOn:dataSet device)
        ].
        form notNil ifTrue:[
            width := width + form width
        ]
    ] ifFalse:[
        width := width + form2 width
    ].
    label notNil ifTrue:[
        width := width max:(label widthOn:dataSet)
    ].
    ^ width := minWidth := width + dataSet separatorSize + (2 * dataSet horizontalSpacing).
!

width:aWidth
    "set the width
    "
    |w|

    description width ~~ 0 ifTrue:[             "/ fixed size
        width := minWidth := description width
    ] ifFalse:[
        width := aWidth max:minWidth
    ].

! !

!DataSetColumn methodsFor:'drawing'!

drawFrom:start to:stop yTop:yTop yBot:yBot with:fg and:bg
    "redraw rows between start and stop
    "
    |lgCol dkCol isLast selRowNr selRowY label drawColSep n
     rowHeight "{ Class:SmallInteger }"
     nTimes    "{ Class:SmallInteger }"
     y         "{ Class:SmallInteger }"
     x         "{ Class:SmallInteger }"
    |
    rowHeight := dataSet rowHeight.
    nTimes    := stop - start + 1.

    y := yTop + textInset.
    x := dataSet horizontalSpacing.
    selRowNr := dataSet selectedRowIndexInColumn:self.

    (selRowNr between:start and:stop) ifTrue:[
        selRowY := selRowNr - 1 * rowHeight.

        dataSet paint:(dataSet hgLgBgColor).
        dataSet fillRectangleX:1
                             y:selRowY
                         width:width - 1
                        height:rowHeight - 1.

        selRowY := selRowY + textInset.

        dataSet paint:(dataSet hgLgFgColor) on:(dataSet hgLgBgColor).

        drawableAction notNil ifTrue:[
            (label := drawableAction value:selRowNr) notNil ifTrue:[
                label displayOn:dataSet x:x y:selRowY
            ]
        ] ifFalse:[
            description rendererType == #rowSelector ifTrue:[
                form2 displayOn:dataSet x:x y:selRowY    
            ]
        ]
    ] ifFalse:[
        selRowY := nil
    ].

    drawableAction notNil ifTrue:[
        dataSet paint:fg on:bg.

        start to:stop do:[:aRowNr|
            (     selRowNr ~~ aRowNr
             and:[(label := drawableAction value:aRowNr) notNil]
            ) ifTrue:[
                label displayOn:dataSet x:x y:y
            ].
            y := y + rowHeight
        ]
    ].
    lgCol := dataSet separatorLightColor.

    form notNil ifTrue:[
        y := yTop + formInset.
        x := width - form width - dataSet separatorSize.

        form2 isNil ifTrue:[
"/            dataSet paint:bg.
"/            dataSet fillRectangleX:(x - 2) y:yTop width:x height:(yBot - yTop).
"/
"/            selRowY notNil ifTrue:[
"/                dataSet paint:(dataSet hgLgBgColor).
"/                dataSet fillRectangleX:(x - 2) y:(selRowY - textInset) width:x height:rowHeight.
"/            ].
            dataSet paint:fg.

            nTimes timesRepeat:[
"/                dataSet displayForm:form x:x y:y.
                dataSet displayOpaqueForm:form x:x y:y.
                y := y + rowHeight.
            ]
        ] ifFalse:[
            dataSet paint:fg.
            x := x // 2.

            start to:stop do:[:i|
                (self at:i) == false ifTrue:[dataSet displayOpaqueForm:form2 x:x y:y]
                                    ifFalse:[dataSet displayOpaqueForm:form  x:x y:y].
                y := y + rowHeight.
            ]
        ].
        y := yTop + formInset.
        dataSet paint:lgCol.

        nTimes timesRepeat:[
            dataSet displayForm:shadowForm x:x y:y.
            y := y + rowHeight.
        ]
    ].

    "/ ************************** DRAW SEPARATORS **************************

    (drawColSep := description showColSeparator) ifTrue:[
        (isLast := dataSet lastColumn == self) ifTrue:[
            drawColSep := dataSet canFit not.
        ]
    ].

    dataSet has3Dsepartors ifFalse:[
        dataSet paint:fg.

        drawColSep ifTrue:[
            dataSet displayLineFromX:width y:yTop toX:width y:yBot.
        ].
        description showRowSeparator ifTrue:[
            y := yTop.

            start > 1 ifTrue:[
                dataSet displayLineFromX:0 y:y toX:width y:y.
            ].

            nTimes timesRepeat:[
                y := y + rowHeight.
                dataSet displayLineFromX:0 y:y toX:width y:y.
            ]
        ].
        ^ self
    ].

    "/ draw 3D separators

    dkCol := dataSet separatorDarkColor.
    dataSet paint:dkCol.

    drawColSep ifTrue:[
        isLast ifFalse:[
            dataSet displayLineFromX:width     y:yTop toX:width     y:yBot.
            dataSet displayLineFromX:width - 1 y:yTop toX:width - 1 y:yBot.
        ].
        dataSet paint:lgCol.
        dataSet displayLineFromX:width - 2 y:yTop toX:width - 2 y:yBot.
        dataSet displayLineFromX:width - 3 y:yTop toX:width - 3 y:yBot.
        dataSet paint:dkCol.
    ].

    description showRowSeparator ifTrue:[
        x := (dataSet firstColumn == self) ifTrue:[0] ifFalse:[1].
        y := yTop.
        n := nTimes.

        start ~~ 1 ifTrue:[n := n + 1]
                  ifFalse:[y := y + rowHeight].

        drawColSep ifTrue:[
            n timesRepeat:[
                dataSet displayLineFromX:x y:y     toX:width-4 y:y.
                dataSet displayLineFromX:x y:y - 1 toX:width-3 y:y - 1.

                dataSet paint:lgCol.
                dataSet displayLineFromX:0 y:y - 2 toX:width     y:y - 2.
                dataSet displayLineFromX:0 y:y - 3 toX:width - 2 y:y - 3.
                dataSet paint:dkCol.
                y := y + rowHeight.
            ]
        ] ifFalse:[
            n timesRepeat:[
                dataSet displayLineFromX:x y:y     toX:width y:y.
                dataSet displayLineFromX:x y:y - 1 toX:width y:y - 1.

                dataSet paint:lgCol.
                dataSet displayLineFromX:0 y:y - 2 toX:width y:y - 2.
                dataSet displayLineFromX:0 y:y - 3 toX:width y:y - 3.
                dataSet paint:dkCol.
                y := y + rowHeight.
            ]
        ]
    ].

    (drawColSep and:[isLast]) ifTrue:[
        dataSet displayLineFromX:width     y:yTop toX:width     y:yBot.
        dataSet displayLineFromX:width - 1 y:yTop toX:width - 1 y:yBot.
    ].

    stop == dataSet size ifTrue:[
        description showRowSeparator ifTrue:[
            dataSet displayLineFromX:0 y:yBot     toX:width y:yBot.
            dataSet displayLineFromX:0 y:yBot - 1 toX:width y:yBot - 1.
        ]
    ].
!

invalidate
    "set to invalidate; forces a recomputation
    "
    width := nil.

! !

!DataSetColumn methodsFor:'event handling'!

doesNotUnderstand:aMessage

    (description respondsTo:(aMessage selector)) ifTrue:[
        ^ aMessage sendTo:description
    ].
    ^ super doesNotUnderstand:aMessage

!

textInsetChanged:aTextInset
    "recompute all attributes
    "
    |lbl|

    drawableAction notNil ifTrue:[
        textInset := dataSet verticalSpacing.

        dataSet numberOfRows ~~ 0 ifTrue:[
            lbl := drawableAction value:1.

            (lbl isString or:[lbl isNumber]) ifTrue:[
                textInset := aTextInset
            ]
        ].

        form notNil ifTrue:[
            formInset := (   dataSet rowHeight 
                           - form height 
                           - dataSet separatorSize
                         ) // 2 + 1
        ] ifFalse:[
            formInset := 0
        ]
    ] ifFalse:[
        formInset := textInset := (   dataSet rowHeight 
                                    - form2 height 
                                    - dataSet separatorSize
                                  ) // 2 + 1.
    ].


! !

!DataSetColumn methodsFor:'grow & degrow'!

growWidth:n
    "grow the width for n pixels
    "
    width := width + n.


!

minWidth
    "get my minimum width required by the entries into the column
    "
    ^ minWidth notNil ifTrue:[minWidth] ifFalse:[self width]


!

setMinWidth
    "set the width to the required width. returns the psitive delta width
    "
    |deltaX|

    deltaX := width - minWidth.
    width  := minWidth.
  ^ deltaX.


! !

!DataSetColumn methodsFor:'initialization'!

on:aDSVColumnView description:aDescription
    "instance creation; set attributes dependent on the description
    "
    |rendererType device selector formatStr idx|

    dataSet        := aDSVColumnView.
    description    := aDescription.
    rendererType   := description rendererType.
    form           := width := form2 := nil.
    device         := dataSet device.
    label          := description label.
    drawableAction := nil.

    description editorType ~~ #None ifTrue:[
        writeSelector := (description readSelector copyWith:$:) asSymbol.
    ].

    label isImage ifTrue:[
        label := label onDevice:device
    ].

    rendererType == #CheckToggle ifTrue:[
        form       := self class formToggleOn  onDevice:device.
        form2      := self class formToggleOff onDevice:device.
        shadowForm := self class formShadow    onDevice:device.
        ^ self
    ].

    rendererType == #rowSelector ifTrue:[
        form2 := self class formRowSelector onDevice:device.
        ^ self
    ].

    (rendererType == #ComboBox or:[rendererType == #ComboList]) ifTrue:[
        form := self class formComboView onDevice:device.
        shadowForm := self class formShadow onDevice:device
    ].

    selector := description printSelector.

    selector notNil ifTrue:[
        drawableAction := [:aRowNr|
            (dataSet list at:aRowNr) perform:selector with:dataSet
        ].
        ^ self
    ].

    selector  := description readSelector.
    formatStr := description formatString.

    (formatStr notNil and:[description type == #number]) ifTrue:[

        "/ has a format string for number (supports only floats)

        (idx := formatStr indexOf:$.) ~~ 0 ifTrue:[
            idx := formatStr size - idx
        ].
        formatStr := '%0.', idx printString, 'f'.

        drawableAction := [:aRowNr||num|
            num := (dataSet list at:aRowNr) perform:selector.
            
            num isReal ifTrue:[
                num := num asFloat printfPrintString:formatStr.
            ].
            num
        ].
        ^ self
    ].

    "/ default: no format string

    drawableAction := [:aRowNr|
        (dataSet list at:aRowNr) perform:selector
    ].

















! !

!DataSetColumn methodsFor:'queries'!

heightOfHighestRow
    "returns the height of the highest row in pixels
    "
    |hObj hMin end|

    hMin := (form ? dataSet font) heightOn:dataSet device.

    (hObj := description height) == 0 ifTrue:[
        drawableAction notNil ifTrue:[
            "/ search first none empty drawable object
            end := 10 min:dataSet numberOfRows.

            1 to:end do:[:aRowNr| |lbl|
                lbl := drawableAction value:aRowNr.

                lbl notNil ifTrue:[
                    (lbl respondsTo:#heightOn:) ifTrue:[
                        hObj := lbl heightOn:dataSet
                    ] ifFalse:[
                        hObj := lbl displayString heightOn:dataSet
                    ].
                    ^ hMin max:hObj
                ]
            ]
        ]
    ].
    ^ hMin max:hObj.
! !

!DataSetColumn methodsFor:'searching'!

findRowNrStartingWithChar:aChar start:start stop:stop
    "find the first row starting at start to stop, which drawable label
     starts with the character, aChar. The index of the detected row is
     returned or if no row is found 0.
    "
    |char|

    drawableAction notNil ifTrue:[
        char  := aChar asLowercase.

        start to:stop do:[:aRowNr| |lbl|
            lbl := drawableAction value:aRowNr.

            lbl isString ifTrue:[
                (lbl size ~~ 0 and:[(lbl at:1) asLowercase == char]) ifTrue:[
                    ^ aRowNr
                ]
            ] ifFalse:[
                lbl isNil ifFalse:[
                    ^ 0
                ]
            ]
        ]
    ].
    ^ 0

! !

!DataSetColumn class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg2/DataSetColumn.st,v 1.1 1997-10-10 13:39:05 ca Exp $'
! !
